function y = randIndex(truth, predicted)

%   The function is to measure similarity between two label assignments
% 	truth: ground truth labels for the dataset (1 x 1496)
% 	predicted: predicted labels (1 x 1496)

    sizeTruth = size(truth,2);
    sizePred = size(predicted,2);
    if ( sizeTruth ~= sizePred)
        y = -1;
    elseif (sizeTruth == 1)
        y = 1;
    end
    agree_same = 0;
    disagree_same =0;
    count = 0;
    for i = 1:(sizeTruth-1)
        for j = (i+1):sizeTruth
            if( (truth(i) == truth(j)) && (predicted(i) == predicted(j)))
                agree_same = agree_same +1;
            elseif( (truth(i) ~= truth(j)) && (predicted(i) ~= predicted(j)))
                disagree_same = disagree_same+1;
            end
            count = count +1;
        end
    end
    y = (agree_same+disagree_same)/count;
end
